<?php
/*
Plugin Name: WordPress Google +1 Button
Plugin URI: http://blog.jacobwg.com/wp-plus-one/
Description: Adds a Google +1 button to your blog posts and pages.
Donate link: http://blog.jacobwg.com/donate/
Tags: Google +1, Google, +1, featured posts, sharing, page, plugin, Post, posts, wordpress like, button, like, custom post type, custom post types, cpt, attachments
Author: Jacob Gillespie
Version: 1.3.0
Requires at least: 3.1.0
Tested up to: 3.2.0
Stable tag: 1.3
Author URI: http://jacobwg.com/
*/

function wp_plus_one_menu() {
	add_options_page(__('Google +1 Button Settings'), __('Google +1 Button'), 'manage_options', 'wp-plus-one', 'wp_plus_one_options');
}

function wp_plus_one_options() {
?>
	<div class="wrap">
	<div id="icon-themes" class="icon32"></div>
	<h2><strong><?php _e('Google +1 Button Settings'); ?></strong></h2>

	<form name="wp_plus_one_option_form" id="wp_plus_one_option_form" method="post">
	
	<h2><?php _e('+1 Button Style') ?></h2>
	
	<div style="float:left; padding: 10px">
		<input type="radio" name="wp-plus-one-style" value="standard" id="wp-plus-one-style-standard"<?php if ((get_option( 'wp-plus-one-style', 'standard' ) == "standard") || (!get_option( 'wp-plus-one-style', 'standard' ))) echo ' checked'; ?>></input>
		<label for="wp-plus-one-style-standard"><?php _e('Standard'); ?></label>
		<?php echo wp_plus_one_button('http://blog.jacobwg.com/'); ?>
	</div>
	<div style="float:left; padding: 10px">
		<input type="radio" name="wp-plus-one-style" value="small" id="wp-plus-one-style-small"<?php if (get_option( 'wp-plus-one-style', 'standard' ) == "small") echo ' checked'; ?>></input>
		<label for="wp-plus-one-style-small"><?php _e('Small'); ?></label>
		<?php echo wp_plus_one_button('http://blog.jacobwg.com/', 'small'); ?>
	</div>
	<div style="float:left; padding: 10px">
		<input type="radio" name="wp-plus-one-style" value="medium" id="wp-plus-one-style-medium"<?php if (get_option( 'wp-plus-one-style', 'standard' ) == "medium") echo ' checked'; ?>></input>
		<label for="wp-plus-one-style-medium"><?php _e('Medium'); ?></label>
		<?php echo wp_plus_one_button('http://blog.jacobwg.com/', 'medium'); ?>
	</div>
	<div style="float:left; padding: 10px">
		<input type="radio" name="wp-plus-one-style" value="tall" id="wp-plus-one-style-tall"<?php if (get_option( 'wp-plus-one-style', 'standard' ) == "tall") echo ' checked'; ?>></input>
		<label for="wp-plus-one-style-tall"><?php _e('Tall'); ?></label>
		<?php echo wp_plus_one_button('http://blog.jacobwg.com/', 'tall'); ?>
	</div>
	
	<h2><?php _e('+1 Button Position') ?></h2>
	<select name="wp-plus-one-position" id="wp-plus-one-position">
		<option value="top_left" <?php if ( get_option( 'wp-plus-one-position', 'top_left' ) == "top_left") echo ' selected'; ?>><?php _e('Top Left (float)'); ?></option>
		<option value="top_right" <?php if (get_option( 'wp-plus-one-position', 'top_left' ) == "top_right") echo 'selected'; ?>><?php _e('Top Right (float)'); ?></option>
		<option value="top" <?php if (get_option( 'wp-plus-one-position', 'top_left' ) == "top") echo 'selected'; ?>><?php _e('Top (no float)'); ?></option>
		<option value="bottom_left" <?php if (get_option( 'wp-plus-one-position', 'top_left' ) == "bottom_left") echo 'selected'; ?>><?php _e('Bottom Left (float)'); ?></option>
		<option value="bottom_right" <?php if (get_option( 'wp-plus-one-position', 'top_left' ) == "bottom_right") echo 'selected'; ?>><?php _e('Bottom Right (float)'); ?></option>
		<option value="bottom" <?php if (get_option( 'wp-plus-one-position', 'top_left' ) == "bottom") echo 'selected'; ?>><?php _e('Bottom (no float)'); ?></option>
		<option value="none" <?php if (get_option( 'wp-plus-one-position', 'top_left' ) == "none") echo 'selected'; ?>><?php _e('None (insert with PHP)'); ?></option>
	</select>
	
	<h2><?php _e('+1 Button Count') ?></h2>
	<p>
		<input type="checkbox" name="wp-plus-one-show-count" id="wp-plus-one-show-count" value="true"<?php if (get_option( 'wp-plus-one-show-count', true ) == true) echo ' checked'; ?>>
		<label for="wp-plus-one-show-count"><?php _e('Show the +1 count with the button'); ?></label>
	</p>
	
	<h2><?php _e('+1 Button Visibility') ?></h2>
	<p>
		<input type="checkbox" name="wp-plus-one-show-on-post" id="wp-plus-one-show-on-post" value="true"<?php if (get_option( 'wp-plus-one-show-on-post', true ) == true) echo ' checked'; ?>>
		<label for="wp-plus-one-show-on-post"><?php _e('Show the +1 button on posts'); ?></label><br />
		<input type="checkbox" name="wp-plus-one-show-on-page" id="wp-plus-one-show-on-page" value="true"<?php if (get_option( 'wp-plus-one-show-on-page', false ) == true) echo ' checked'; ?>>
		<label for="wp-plus-one-show-on-page"><?php _e('Show the +1 button on pages'); ?></label><br />
		<input type="checkbox" name="wp-plus-one-show-on-attachment" id="wp-plus-one-show-on-attachment" value="true"<?php if (get_option( 'wp-plus-one-show-on-attachment', false ) == true) echo ' checked'; ?>>
		<label for="wp-plus-one-show-on-attachment"><?php _e('Show the +1 button on attachments (like images)'); ?></label><br />
		<?php
		
		$args = array(
		  'public'   => true,
		  '_builtin' => false
		); 
		$post_types = get_post_types($args); 
		foreach ($post_types as $post_type ) {
			$post_type = get_post_type_object($post_type);
		?>
		<input type="checkbox" name="wp-plus-one-show-on-<?php echo $post_type->name; ?>" id="wp-plus-one-show-on-<?php echo $post_type->name; ?>" value="true"<?php if (get_option( 'wp-plus-one-show-on-' . $post_type->name, false ) == true) echo ' checked'; ?>>
		<label for="wp-plus-one-show-on-<?php echo $post_type->name; ?>"><?php _e('Show the +1 button on ' . $post_type->labels->name ); ?></label><br />
		<?php
		}
		?>
	</p>
	
	<h2><?php _e('+1 Button Custom CSS') ?></h2>
	<p>
		<textarea name="wp-plus-one-css" id="wp-plus-one-css" rows="10" cols="50"><?php echo get_option( 'wp-plus-one-css', '' ); ?></textarea>
	</p>
	
	<p>
		<input type="submit" value="Save Settings" class="button-primary" />
		<input type="hidden" name="wp-plus-one-form-submit" value="true" />
	</p>
	
	<p>
		<strong><?php _e('WordPress Hook:'); ?></strong> <?php _e('If you selected <em>None</em> as the +1 Button position or would like to add additional +1 Buttons to your theme, please use the <code>&lt;?php do_action( \'wp_plus_one_button\', $url, $style, $css); ?&gt;</code> hook in your plugin or theme.'); ?>
	</p>
	<p>
		<strong><?php _e('Hook Options:'); ?></strong> <?php _e('<code>$url</code> (optional) is the URL to +1 (will be <code>the_permalink()</code> if blank), <code>$style</code> (optional) is the button style (standard, small, medium, tall), and <code>$css</code> (optional) is any extra CSS to add to the button <code>DIV</code>.'); ?>
	</p>
	
	</form>
</div>
	


	
<?php
}


function wp_plus_one_init()
{
	if(isset($_POST['wp-plus-one-form-submit']))
	{
		// wp-plus-one-position
		// wp-plus-one-layout
		// wp-plus-one-show-count
		// wp-plus-one-show-on-post
		// wp-plus-one-show-on-page
		// wp-plus-one-show-on-attachment
		// wp-plus-one-css
		
		update_option('wp-plus-one-position', $_POST['wp-plus-one-position']);
		update_option('wp-plus-one-style', $_POST['wp-plus-one-style']);
		update_option('wp-plus-one-show-count', $_POST['wp-plus-one-show-count'] == 'true');
		update_option('wp-plus-one-show-on-post', $_POST['wp-plus-one-show-on-post'] == 'true');
		update_option('wp-plus-one-show-on-page', $_POST['wp-plus-one-show-on-page'] == 'true');
		update_option('wp-plus-one-show-on-attachment', $_POST['wp-plus-one-show-on-attachment'] == 'true');
		update_option('wp-plus-one-css', $_POST['wp-plus-one-css']);
		
		// save settings for custom post types
		$args = array(
		  'public'   => true,
		  '_builtin' => false
		); 
		$post_types = get_post_types($args); 
		foreach ($post_types as $post_type ) {
			update_option( 'wp-plus-one-show-on-' . $post_type, $_POST['wp-plus-one-show-on-' . $post_type] == 'true' );
		}
		
		add_action('admin_notices', 'wp_plus_one_save_message');

	}
	
	wp_enqueue_script( 'wp-plus-one', 'http://apis.google.com/js/plusone.js', null, '1.0.0', true );
}

function wp_plus_one_save_message() { echo '<div id="message" class="updated fade">' . __('Google +1 Button Settings Saved') . '</div>'; }


function wp_plus_one_button( $url='', $size='', $css='' ) {

	if ( !$url )
		$url = get_permalink();
	if ( !$url )
		return;

	if ( $css )
		$tag = '<div class="wp_plus_one_button" style="' . $css . '"><g:plusone';
	else
		$tag = '<div class="wp_plus_one_button"><g:plusone';
	
	if ( $size && $size != 'standard' )
		$tag .= ' size="' . $size . '"';
	
	$tag .= ' href="' . $url . '"';
	
	$tag .= '></g:plusone></div>';
	
	return $tag;

}
function wp_plus_one_button_echo( $url='', $size='', $css='' ) {
	echo apply_filters( 'wp_plus_one_button', wp_plus_one_button( $url, $size, $css) );
}

add_action( 'wp_plus_one_button', 'wp_plus_one_button_echo' );

function wp_plus_one( $content ) {

	if ( 
		(	get_option('wp-plus-one-position', 'top_left') != 'none' 					// hide if it is set to none
		&& 	( !is_single() || get_option( 'wp-plus-one-show-on-post', true ) == true ) 	// show if it is a post (default: true)
		&&  ( !is_page() || get_option( 'wp-plus-one-show-on-page', false ) == true )	// show if it is a page (default: false)
		&&  ( !is_attachment() || get_option( 'wp-plus-one-show-on-attachment', false ) == true )	// show if it is a page (default: false)
		&& 	!is_feed() && !is_archive() && !is_search() && !is_404() )
		||  ( get_post_type(get_the_ID()) && get_option( 'wp-plus-one-show-on-' . get_post_type(get_the_ID()), false ) == true )
	) {
		
		if (get_the_id() && get_post_meta(get_the_id(), 'wp_plus_one_disabled') == true)
			return $content;
		
		$url = get_permalink();
		$style = get_option('wp-plus-one-style', 'standard');
		$css = get_option( 'wp-plus-one-css', '' );
		
		
		switch( get_option('wp-plus-one-position', 'top_left') )
		{
			case 'top_left':
				return wp_plus_one_button( $url, $style, 'margin: 0 8px 8px 0; float:left; ' . $css ) . $content;
				break;
			case 'top_right':
				return wp_plus_one_button( $url, $style, 'margin: 0 0 8px 8px; float:right; ' . $css ) . $content;
				break;
			case 'top':
				return wp_plus_one_button( $url, $style, $css ) . $content;
				break;
			case 'bottom_left':
				return $content . wp_plus_one_button( $url, $style, 'margin: 8px 8px 0 0; float:left; ' . $css );
				break;
			case 'bottom_right':
				return $content . wp_plus_one_button( $url, $style, 'margin: 8px 0 0 8px; float:right; ' . $css );
				break;
			case 'bottom':
				return $content . wp_plus_one_button( $url, $style, $css );
				break;
		}
	}

	return $content;
}

function wp_plus_one_admin_css() {
	echo '<style type="text/css"> #wp_plus_one_option_form h2 { clear: both; } #wp_plus_one_option_form .wp_plus_one_button { margin: 8px; } </style>';
}

add_action('admin_head', 'wp_plus_one_admin_css');
add_filter('the_content', 'wp_plus_one');
add_action('admin_menu', 'wp_plus_one_menu');
add_action('init', 'wp_plus_one_init');


function wp_plus_one_add_meta_box() {
	if ( get_option( 'wp-plus-one-show-on-post', true ) )
		add_meta_box( 'wp_plus_one_meta', __('Google +1 Settings'), 'wp_plus_one_meta_box_content', 'post', 'advanced', 'high' );
	if ( get_option( 'wp-plus-one-show-on-page', false ) )
		add_meta_box( 'wp_plus_one_meta', __('Google +1 Settings'), 'wp_plus_one_meta_box_content', 'page', 'advanced', 'high' );
	
	// add metabox to custom post types
	$args = array(
	  'public'   => true,
	  '_builtin' => false
	); 
	$post_types = get_post_types($args); 
	foreach ($post_types as $post_type ) {
		if ( get_option( 'wp-plus-one-show-on-' . $post_type, false ) )
			add_meta_box( 'wp_plus_one_meta', __('Google +1 Settings'), 'wp_plus_one_meta_box_content',  $post_type, 'advanced', 'high' );
	}
}

function wp_plus_one_meta_box_content( $post ) {
	$wp_plus_one_checked = get_post_meta( $post->ID, 'wp_plus_one_disabled', false );

	if ( empty( $wp_plus_one_checked ) || $wp_plus_one_checked === false )
		$wp_plus_one_checked = ' checked="checked"';
	else
		$wp_plus_one_checked = '';

	echo '<p><label for="enable_post_wp_plus_one"><input name="enable_post_wp_plus_one" id="enable_post_wp_plus_one" value="1"' . $wp_plus_one_checked . ' type="checkbox"> ' . __('Show the +1 button on this post.') . '</label><input type="hidden" name="wp_plus_one_status_hidden" value="1" /></p>';
}

function wp_plus_one_meta_box_save( $post_id ) {
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
		return $post_id;

	// Record wp_plus_one disable
	if ( 'post' == $_POST['post_type'] || 'page' == $_POST['post_type'] ) {
		if ( current_user_can( 'edit_post', $post_id ) ) {
			if ( isset( $_POST['wp_plus_one_status_hidden'] ) ) {
				if ( !isset( $_POST['enable_post_wp_plus_one'] ) )
					update_post_meta( $post_id, 'wp_plus_one_disabled', 1 );
				else
					delete_post_meta( $post_id, 'wp_plus_one_disabled' );
			}
		}
	}

  return $post_id;
}

function wp_plus_one_plugin_settings( $links ) {
	$settings_link = '<a href="options-general.php?page=wp-plus-one">'.__('Settings').'</a>';
	array_unshift( $links, $settings_link );
	return $links;
}

function wp_plus_one_add_plugin_settings($links, $file) {
	if ( $file == basename( dirname( __FILE__ ) ).'/'.basename( __FILE__ ) ) {
		$links[] = '<a href="options-general.php?page=wp-plus-one">' . __('Settings') . '</a>';
		$links[] = '<a href="http://blog.jacobwg.com/wp-plus-one/">' . __('Support') . '</a>';
	}
	
	return $links;
}

add_action( 'admin_init', 'wp_plus_one_add_meta_box' );
add_action( 'save_post', 'wp_plus_one_meta_box_save' );
add_action( 'plugin_action_links_'.basename( dirname( __FILE__ ) ).'/'.basename( __FILE__ ), 'wp_plus_one_plugin_settings', 10, 4 );
add_filter( 'plugin_row_meta', 'wp_plus_one_add_plugin_settings', 10, 2 );